
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class End_of_summer_trip_optionsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const end_of_summer_trip_options = await db.end_of_summer_trip_options.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        option_type: data.option_type
        ||
        null
            ,
            
        destination: data.destination
        ||
        null
            ,
            
        estimated_price: data.estimated_price
        ||
        null
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await end_of_summer_trip_options.setCamp_session( data.camp_session || null, {
            transaction,
        });
        

        

        

        return end_of_summer_trip_options;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const end_of_summer_trip_optionsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                option_type: item.option_type
            ||
            null
            ,
            
                destination: item.destination
            ||
            null
            ,
            
                estimated_price: item.estimated_price
            ||
            null
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const end_of_summer_trip_options = await db.end_of_summer_trip_options.bulkCreate(end_of_summer_trip_optionsData, { transaction });

        // For each item created, replace relation files
        

        return end_of_summer_trip_options;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const end_of_summer_trip_options = await db.end_of_summer_trip_options.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.option_type !== undefined) updatePayload.option_type = data.option_type;
        
        
        if (data.destination !== undefined) updatePayload.destination = data.destination;
        
        
        if (data.estimated_price !== undefined) updatePayload.estimated_price = data.estimated_price;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        updatePayload.updatedById = currentUser.id;

        await end_of_summer_trip_options.update(updatePayload, {transaction});

        
        
        if (data.camp_session !== undefined) {
            await end_of_summer_trip_options.setCamp_session(
              
              data.camp_session,
              
              { transaction }
            );
        }
        

        
        

        

        return end_of_summer_trip_options;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const end_of_summer_trip_options = await db.end_of_summer_trip_options.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of end_of_summer_trip_options) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of end_of_summer_trip_options) {
                await record.destroy({transaction});
            }
        });


        return end_of_summer_trip_options;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const end_of_summer_trip_options = await db.end_of_summer_trip_options.findByPk(id, options);

        await end_of_summer_trip_options.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await end_of_summer_trip_options.destroy({
            transaction
        });

        return end_of_summer_trip_options;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const end_of_summer_trip_options = await db.end_of_summer_trip_options.findOne(
            { where },
            { transaction },
        );

        if (!end_of_summer_trip_options) {
            return end_of_summer_trip_options;
        }

        const output = end_of_summer_trip_options.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.end_of_summer_trip_selections_trip_option = await end_of_summer_trip_options.getEnd_of_summer_trip_selections_trip_option({
            transaction
        });
        
        
        
        
        
        
        
        output.camp_session = await end_of_summer_trip_options.getCamp_session({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.camp_sessions,
        as: 'camp_session',
        
        where: filter.camp_session ? {
          [Op.or]: [
            { id: { [Op.in]: filter.camp_session.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.camp_session.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'end_of_summer_trip_options',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.destination) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'end_of_summer_trip_options',
                        'destination',
                        filter.destination,
                    ),
                };
            }
            

            
            

            
            if (filter.estimated_priceRange) {
                const [start, end] = filter.estimated_priceRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    estimated_price: {
                    ...where.estimated_price,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    estimated_price: {
                    ...where.estimated_price,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.option_type) {
                where = {
                    ...where,
                option_type: filter.option_type,
            };
            }
            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.end_of_summer_trip_options.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'end_of_summer_trip_options',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.end_of_summer_trip_options.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

